unit RedColorMap;

interface

uses
  Windows, SysUtils, Classes, ActnMan, Graphics, GraphUtil;

type
  TRedColorMap = class(TCustomActionBarColorMap)
  public
    procedure UpdateColors; override;
  published
    property ShadowColor;
    property Color;
    property DisabledColor;
    property DisabledFontColor;
    property DisabledFontShadow;
    property FontColor;
    property HighlightColor;
    property HotColor;
    property HotFontColor;
    property MenuColor;
    property FrameTopLeftInner;
    property FrameTopLeftOuter;
    property FrameBottomRightInner;
    property FrameBottomRightOuter;
    property BtnFrameColor;
    property BtnSelectedColor;
    property SelectedColor;
    property SelectedFontColor;
    property UnusedColor;
    property OnColorChange;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Vampyre Shared', [TRedColorMap]);
end;

{ TRedColorMap }

procedure TRedColorMap.UpdateColors;
begin
  inherited;
  Color := clBtnFace;
  MenuColor := clWindow;
  BtnFrameColor := $008080FF;
  BtnSelectedColor := clBtnFace;
  DisabledFontColor := clGrayText;
  DisabledFontShadow := clBtnHighlight;
  DisabledColor := clGray;
  FontColor := clWindowText;
  FrameTopLeftInner := clWhite;
  FrameTopLeftOuter := $00000080;
  FrameBottomRightInner := clWhite;
  FrameBottomRightOuter := $00000080;
  HighlightColor := GetHighLightColor(clBtnFace, 15);
  HotColor := clDefault;
  HotFontColor := clDefault;
  SelectedColor := $00CACAFF;
  SelectedFontColor := clBlack;
  ShadowColor := cl3DDkShadow;
  UnusedColor := GetHighLightColor(clBtnFace, 15);
end;

end.
