unit CSingletons;

interface

uses
  Kernel, CBase, CProjects, CEditor;

function FileTypes: TVideFileTypeList;
function Solution: TVideSolution;
function Editor: TVideEditor;

implementation

var
  FileTypesInstance:TVideFileTypeList = nil;
  SolutionInstance:TVideSolution = nil;
  EditorInstance:TVideEditor = nil;

function FileTypes: TVideFileTypeList;
begin
  if FileTypesInstance = nil then
   FileTypesInstance:=TVideFileTypeList.Create;
  Result:=FileTypesInstance;
end;

function Solution: TVideSolution;
begin
  if SolutionInstance = nil then
    SolutionInstance:=TVideSolution.Create;
  Result:=SolutionInstance;
end;

function Editor: TVideEditor;
begin
  if EditorInstance = nil then
    EditorInstance:=TVideEditor.Create;
  Result:=EditorInstance;
end;

initialization
finalization
  FreeAndNil(FileTypesInstance);
  FreeAndNil(SolutionInstance);
  FreeAndNil(EditorInstance);
end.
