{*************************************************************************}
{*   VgiFormat                                                           *}
{*   Copyright (C) 2003 Marek Mauder, Vampyre SoftWorks                  *}
{*   Graphic\ImageFileFormats\VgiFormat.pas                              *}
{*************************************************************************}
{                                                                         }
{ This program is free software; you can redistribute it and/or modify it }
{ under the terms of the GNU General Public License as published by the   }
{ Free Software Foundation; either version 2 of the License, or (at your  }
{ option) any later version. This program is distributed in the hope that }
{ it will be useful, but WITHOUT ANY WARRANTY; without even the implied   }
{ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See   }
{ the GNU General Public License for more details.                        }
{                                                                         }
{ You should have received a copy of the GNU General Public License       }
{ along with this program; if not, write to the Free Software Foundation, }
{ Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         }
{                                                                         }
{*************************************************************************}
{  Created On: 14th September 2003  (14.09.2003)                          }
{*************************************************************************}

{This unit contains loader/saver of images in native Vampyre Graphic Imaging
format which has many capabilities.}

unit VgiFormat;

{TODO -oGalfar : Wait for Vampyre File format definition in Files dir.}

{$I Compiler.inc}

interface

uses
  SysUtils, Kernel, Objects, Platforms, Graphic, Images;

type

  {Image encoder for loading/saving VGI file format.}
  TNVGIFormat = class(TNImageFileFormat)
  protected
    procedure PrepareImage(const Image: TImageData; var Clone: TImageData);
      override;
    procedure DoLoadImage(var Image: TImageData; Stream: TNStream); override;
    procedure DoSaveImage(var Image: TImageData; Stream: TNStream;
      SaveCompressed: Boolean); override;
  public
    constructor Create; override;
    function TestFormat(Stream: TNStream): Boolean; override;
  end;

const

  sVGIExtensions = 'vgi';
  sVGIFormatName = 'Vampyre Graphic Imaging';

var

  VGIInstance: TNVGIFormat = nil;


{*************************************************************************}
{                             IMPLEMEMTATION                              }
{*************************************************************************}


implementation


{*************************************************************************}
{                        TNVGIFormat methods                              }
{*************************************************************************}


constructor TNVGIFormat.Create;
begin
  inherited Create;
  FExtensions := sVGIExtensions;
  FFormatName := sVGIFormatName;
  FCanLoad := not True;
  FCanSave := not True;
end;

procedure TNVGIFormat.PrepareImage(const Image: TImageData;
  var Clone: TImageData);
begin
  inherited PrepareImage(Image, Clone);
end;

procedure TNVGIFormat.DoLoadImage(var Image: TImageData; Stream: TNStream);
begin

end;

procedure TNVGIFormat.DoSaveImage(var Image: TImageData; Stream: TNStream;
  SaveCompressed: Boolean);
begin

end;

function TNVGIFormat.TestFormat(Stream: TNStream): Boolean;
begin
  Result := False;
end;


{*************************************************************************}
{                         Internal Stuff                                  }
{*************************************************************************}


initialization

  VGIInstance := TNVGIFormat.Create;

finalization

  FreeAndNil(VGIInstance);

end.

