{*************************************************************************}
{*   DosPlatform                                                         *}
{*   Copyright (C) 2003 Marek Mauder, Vampyre SoftWorks                  *}
{*   Engine\Kernel\Platforms\Dos\DosPlatform.pas                         *}
{*************************************************************************}
{                                                                         }
{ This program is free software; you can redistribute it and/or modify it }
{ under the terms of the GNU General Public License as published by the   }
{ Free Software Foundation; either version 2 of the License, or (at your  }
{ option) any later version. This program is distributed in the hope that }
{ it will be useful, but WITHOUT ANY WARRANTY; without even the implied   }
{ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See   }
{ the GNU General Public License for more details.                        }
{                                                                         }
{ You should have received a copy of the GNU General Public License       }
{ along with this program; if not, write to the Free Software Foundation, }
{ Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         }
{                                                                         }
{*************************************************************************}
{  Created On: 14th March 2004  (14.03.2003)                              }
{*************************************************************************}

{This unit contains EXPERIMENTAL descendant of TNPlatform designed
 for DOS platform.}

unit DosPlatform;

{$I Compiler.inc}

{Settings for module libraries' names - do not start
 with "lib" and end with "Dos".}
{$IFDEF MODLIBRARY}
  {$LIBPREFIX ''}
  {$LIBSUFFIX 'Dos'}
{$ENDIF}

interface

uses
  SysUtils, Kernel, Objects, Platforms
{$IFNDEF MODLIBRARY}
  , DosSysInfo
{$ENDIF};

type

  TNPlatformDos = class(TNPlatform)
  protected
    procedure GatherStaticInfo; override;
    procedure GatherDynamicInfo(Index: Long); override;
  public
    procedure MsgBox(const FormatStr: NString; const Args: array of const); override;
    function ErrorMsg(const Msg: NString): TErrorMsgResult; override;
    function GetModuleFileName(Handle: THandle): NString; override;
    function LoadLibrary(const FileName: NString): THandle; override;
    function UnloadLibrary(Handle: THandle): Boolean; override;
    function GetProcAddress(Handle: THandle; const ProcName: NString): Pointer;
      override;
    function IsExecutable(const FileName: NString): Boolean; override;
    function GetTimeMicroseconds: Int64; override;
    procedure Sleep(Milliseconds:ULong);override;
  end;


{*************************************************************************}
{                             Implementation                              }
{*************************************************************************}


implementation


{*************************************************************************}
{                         TNPlatformDos methods                        }
{*************************************************************************}


procedure TNPlatformDos.GatherStaticInfo;
begin
{$IFNDEF MODLIBRARY}
   DosSysInfo.GetCPUInfo(FCPUInfo);
{$ENDIF};
end;

procedure TNPlatformDos.GatherDynamicInfo(Index: Long);
begin
end;

procedure TNPlatformDos.MsgBox(const FormatStr: NString;
  const Args: array of const);
begin
end;

function TNPlatformDos.ErrorMsg(const Msg: NString): TErrorMsgResult;
begin
end;

function TNPlatformDos.GetModuleFileName(Handle: THandle): NString;
begin
end;

function TNPlatformDos.LoadLibrary(const FileName: NString): THandle;
begin
end;

function TNPlatformDos.UnloadLibrary(Handle: THandle): Boolean;
begin
end;

function TNPlatformDos.GetProcAddress(Handle: THandle;
  const ProcName: NString): Pointer;
begin
end;

function TNPlatformDos.IsExecutable(const FileName: NString): Boolean;
begin
end;

function TNPlatformDos.GetTimeMicroseconds: Int64;
begin
end;

procedure TNPlatformDos.Sleep(Milliseconds: ULong);
begin
end;

end.
