{*************************************************************************}
{*   DosSysInfo                                                          *}
{*   Copyright (C) 2003 Marek Mauder, Vampyre SoftWorks                  *}
{*   Engine\Kernel\Platforms\Dos\DosSysInfo.pas                          *}
{*************************************************************************}
{                                                                         }
{ This program is free software; you can redistribute it and/or modify it }
{ under the terms of the GNU General Public License as published by the   }
{ Free Software Foundation; either version 2 of the License, or (at your  }
{ option) any later version. This program is distributed in the hope that }
{ it will be useful, but WITHOUT ANY WARRANTY; without even the implied   }
{ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See   }
{ the GNU General Public License for more details.                        }
{                                                                         }
{ You should have received a copy of the GNU General Public License       }
{ along with this program; if not, write to the Free Software Foundation, }
{ Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         }
{                                                                         }
{*************************************************************************}
{  Created On: 9th May 2004  (09.05.2004)                                 }
{*************************************************************************}

{Contains function for retrieve CPU, memory and other system info under Dos}

unit DosSysInfo;

{$I Compiler.inc}

interface

uses
  SysUtils, Kernel, Platforms
{$IFNDEF MODLIBRARY}
  , X86CpuInfo
{$ENDIF};

procedure GetCPUInfo(var Info: TCPUInfo);
procedure GetOSInfo(var Version: TVersionInfo; var Name: NString);
procedure GetMemoryInfo(var Info: TMemoryInfo);


implementation

function DosPITFunction:Int64;
asm
  XOR    EAX, EAX
  CLI
  OUT    $43, AL
  MOV    EDX, FS:[$46C]
  IN     AL, $40
  DB     $EB, 0, $EB, 0, $EB, 0
  MOV    AH, AL
  IN     AL, $40
  DB     $EB, 0, $EB, 0, $EB, 0
  XCHG   AL, AH
  NEG    AX
  MOVZX  EDI, AX
  STI
  MOV    EBX, $10000
  MOV    EAX, EDX
  XOR    EDX, EDX
  MUL    EBX
  ADD    EAX, EDI
  ADC    EDX, 0
  PUSH   EDX
  PUSH   EAX
  MOV    ECX, $82BF1000
  MOVZX  EAX, WORD PTR FS:[$470]
  MUL    ECX
  MOV    ECX, EAX
  POP    EAX
  POP    EDX
  ADD    EAX, ECX
  ADC    EDX, 0
end;

procedure GetCPUInfo(var Info: TCPUInfo);
begin
  // reset PIT
  asm
    MOV    EAX, $34
    OUT    $43, AL
    XOR    EAX, EAX
    OUT    $40, AL
    OUT    $40, AL
  end;
  X86CpuInfo.GetX86CPUInfo(Info, $1234DD, DosPITFunction);
end;

procedure GetOSInfo(var Version: TVersionInfo; var Name: NString);
begin

end;

procedure GetMemoryInfo(var Info: TMemoryInfo);
begin

end;

end.

