{*************************************************************************}
{*   DotNetPlatform                                                      *}
{*   Copyright (C) 2003 Marek Mauder, Vampyre SoftWorks                  *}
{*   Engine\Kernel\Platforms\DotNet\DotNetPlatform.pas                   *}
{*************************************************************************}
{                                                                         }
{ This program is free software; you can redistribute it and/or modify it }
{ under the terms of the GNU General Public License as published by the   }
{ Free Software Foundation; either version 2 of the License, or (at your  }
{ option) any later version. This program is distributed in the hope that }
{ it will be useful, but WITHOUT ANY WARRANTY; without even the implied   }
{ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See   }
{ the GNU General Public License for more details.                        }
{                                                                         }
{ You should have received a copy of the GNU General Public License       }
{ along with this program; if not, write to the Free Software Foundation, }
{ Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         }
{                                                                         }
{*************************************************************************}
{  Created On: 14th March 2004  (14.03.2003)                              }
{*************************************************************************}

{This unit contains EXPERIMENTAL descendant of TNPlatform designed
 for .NET platform.}

unit DotNetPlatform;

{$I Compiler.inc}

interface

uses
  SysUtils, Kernel, Objects, Platforms;

type

  TNPlatformDotNet = class(TNPlatform)
  protected
    procedure GatherStaticInfo; override;
    procedure GatherDynamicInfo(Index: Long); override;
  public
    procedure MsgBox(const FormatStr: NString; const Args: array of const); override;
    function ErrorMsg(const Msg: NString): TErrorMsgResult; override;
    function GetModuleFileName(Handle: THandle): NString; override;
    function LoadLibrary(const FileName: NString): THandle; override;
    function UnloadLibrary(Handle: THandle): Boolean; override;
    function GetProcAddress(Handle: THandle; const ProcName: NString): Pointer;
      override;
    function IsExecutable(const FileName: NString): Boolean; override;
    function GetTimeMicroseconds: Int64; override;
    procedure Sleep(Milliseconds:ULong);override;
  end;


{*************************************************************************}
{                             Implementation                              }
{*************************************************************************}


implementation


{*************************************************************************}
{                         TNPlatformDotNet methods                        }
{*************************************************************************}


function TNPlatformDotNet.ErrorMsg(const Msg: NString): TErrorMsgResult;
begin
end;

procedure TNPlatformDotNet.GatherDynamicInfo(Index: Long);
begin
end;

procedure TNPlatformDotNet.GatherStaticInfo;
begin
end;

function TNPlatformDotNet.GetModuleFileName(Handle: THandle): NString;
begin
end;

function TNPlatformDotNet.GetProcAddress(Handle: THandle;
  const ProcName: NString): Pointer;
begin
end;

function TNPlatformDotNet.GetTimeMicroseconds: Int64;
begin
end;

function TNPlatformDotNet.IsExecutable(const FileName: NString): Boolean;
begin
end;

function TNPlatformDotNet.LoadLibrary(const FileName: NString): THandle;
begin
end;

procedure TNPlatformDotNet.MsgBox(const FormatStr: NString;
  const Args: array of const);
begin
end;

procedure TNPlatformDotNet.Sleep(Milliseconds: ULong);
begin
end;

function TNPlatformDotNet.UnloadLibrary(Handle: THandle): Boolean;
begin
end;

end.
