unit StdDropBtn;

interface

uses Windows, ActnCtrls;

type
  TStandardDropDownButton = class(TCustomDropDownButton)
  protected
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
  end;

implementation

uses Graphics, GraphUtil, Buttons;

{ TStandardDropDownButton }

procedure TStandardDropDownButton.DrawFrame(ARect: TRect; Down: Boolean);

  procedure DrawBtnFrame(ARect: TRect; Down: Boolean);
  var
    Clrs: array[Boolean] of TColor;
  begin
    if Enabled and ((FState = bsDown) or not Flat or MouseInControl or IsChecked) then
    begin
      Clrs[False] := GetHighLightColor(Color);
      Clrs[True] := GetShadowColor(Color);
      Canvas.Pen.Color := Clrs[Down];
      Canvas.MoveTo(ARect.Right - Integer(not Down), ARect.Top);
      Canvas.LineTo(ARect.Left, ARect.Top);
      Canvas.LineTo(ARect.Left, ARect.Bottom - Integer(not Down));
      Canvas.Pen.Color := Clrs[not Down];
      Canvas.MoveTo(ARect.Right - 1, ARect.Top - Integer(Down));
      Canvas.LineTo(ARect.Right - 1, ARect.Bottom - 1);
      Canvas.LineTo(ARect.Left{-1 }+ Integer(Down), ARect.Bottom - 1);
    end;
  end;

begin
  Dec(ARect.Right, 9);
  DrawBtnFrame(ARect, Down and not MouseOverDropDown);
  ARect.Left := ARect.Right;
  Inc(ARect.Right, 9);
  DrawBtnFrame(ARect, Down or DroppedDown);
end;

end.
