unit ABase;

interface

uses
  Kernel, SynEditTypes, SynEditTextBuffer, CBase, AConsts,
  ActnMan, Lists, Objects;

type

  TNewItemCategory = (ntSolutions, ntProjects, ntFiles, ntTemplates);
  TNewItems = set of TNewItemCategory;

  TFixedTypePos = (fpTop, fpBottom, fpNone);

  TSaveItemCategory = (scSolutions, scProjects, scActiveFile, scEditorFiles);
  TSaveItems = set of TSaveItemCategory;

  TSearchMode = (smFindNew, smReplaceNew, smNext);

  TSearchOptions = record
    Text: string;
    ReplaceText: string;
    SynOptions: TSynSearchOptions;
  end;

  TEditorHook = class
  public
    UndoList: TSynEditUndoList;
    RedoList: TSynEditUndoList;
    Buffer: TSynEditStringList;
    constructor Create;
    destructor Destroy; override;
  end;

  TSyntaxNames = array[TTextType] of string;

const
  AllNewItems: TNewItems = [ntSolutions..ntTemplates];
  AllSaveItems: TSaveItems = [scSolutions..scEditorFiles];

  SaveFormIndent = 4;

  ExpSolution = 0;
  ExpSource = 1;
  ExpDisk = 2;

  SyntaxNames: TSyntaxNames = (sSNNone, sSNPascal, sSNCpp, sSNAsm, sSNJava,
    sSNCSharp, sSNBasic, sSNDelphiForm, sSNXML, sSNHTML, sSNINI);

implementation

{ TEditorHook }

constructor TEditorHook.Create;
begin
  Buffer := TSynEditStringList.Create;
  UndoList := TSynEditUndoList.Create;
  RedoList := TSynEditUndoList.Create;
end;

destructor TEditorHook.Destroy;
begin
  Buffer.Free;
  UndoList.Free;
  RedoList.Free;
  inherited Destroy;
end;

end.

