unit FData;

interface

uses
  SysUtils, Classes, ActnColorMaps, ActnMan, SynEditOptionsDialog,
  SynEditMiscClasses, SynEditSearch, SynHighlighterIni, SynHighlighterDfm,
  SynHighlighterAsm, SynHighlighterXML, SynHighlighterCSS,
  SynHighlighterHtml, SynHighlighterCS, SynHighlighterVB,
  SynHighlighterJava, SynHighlighterCpp, SynEditHighlighter,
  SynHighlighterPas, SynExportRTF, SynEditExport, SynExportHTML, XPMan,
  AppEvnts, Dialogs, RedColorMap, ABase, AOptions, AConsts;

type
  TData = class(TDataModule)
    XPColors: TXPColorMap;
    StdColors: TStandardColorMap;
    CustomColors: TStandardColorMap;
    SynSearch: TSynEditSearch;
    SynOptions: TSynEditOptionsDialog;
    ExportHTML: TSynExporterHTML;
    ExportRTF: TSynExporterRTF;
    PasSyn: TSynPasSyn;
    CppSyn: TSynCppSyn;
    JavaSyn: TSynJavaSyn;
    BasicSyn: TSynVBSyn;
    CSharpSyn: TSynCSSyn;
    HTMLSyn: TSynHTMLSyn;
    CssSyn: TSynCssSyn;
    XMLSyn: TSynXMLSyn;
    AsmSyn: TSynAsmSyn;
    DfmSyn: TSynDfmSyn;
    INISyn: TSynIniSyn;
    XPMan: TXPManifest;
    SaveD: TSaveDialog;
    OpenD: TOpenDialog;
    AppEvents: TApplicationEvents;
    RedColors: TRedColorMap;
    procedure AppEventsIdle(Sender: TObject; var Done: Boolean);
    procedure SaveDTypeChange(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Data: TData;

implementation

uses
  AMainActions, AEditorActions, AExpActions, CSingletons;

{$R *.dfm}

procedure TData.AppEventsIdle(Sender: TObject; var Done: Boolean);
begin
  MainActions.Idle;
  ExpActions.Idle;
  EditorActions.Idle;
end;

procedure TData.SaveDTypeChange(Sender: TObject);
begin
  if SaveD.FilterIndex > FileTypes.Count then
    SaveD.DefaultExt := ''
  else
    SaveD.DefaultExt := FileTypes.Types[SaveD.FilterIndex - 1].Extensions[0];
end;

procedure TData.DataModuleCreate(Sender: TObject);
begin
  RegisterColorMap(sXPStyleColors, XPColors);
  RegisterColorMap(sStandardColors, StdColors);
  RegisterColorMap(sRedColors, RedColors);
end;

end.
