unit FFileNew;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, WizardHeader, ImgList, Kernel, ABase,
  AMainActions, ANewItems, AConsts;

type
  TNewForm = class(TForm)
    Panel1: TPanel;
    BtnOK: TButton;
    Button2: TButton;
    Header: TWizardHeader;
    Panel2: TPanel;
    Label1: TLabel;
    ImagesNew: TImageList;
    Panel3: TPanel;
    TreeNew: TTreeView;
    ViewNew: TListView;
    LabSelCat: TLabel;
    Icons: TImageList;
    LabWin32: TLabel;
    procedure TreeNewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TreeNewChange(Sender: TObject; Node: TTreeNode);
    procedure ViewNewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure ViewNewDblClick(Sender: TObject);
    procedure TreeNewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeNewCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
  private
    FAllowedItems: TNewItems;
    FLastItem: TNewItem;
    FLastCat: TNewItemCategory;
  public
    function ShowNewItems(AllowedItems: TNewItems =
      [ntSolutions..ntTemplates]): TNewItem;
  end;

var
  NewForm: TNewForm;

implementation

uses
  FMain;

{$R *.dfm}

function TNewForm.ShowNewItems(AllowedItems: TNewItems): TNewItem;
var
  StdRoot, TempRoot, Item: TTreeNode;
begin
  Result := nil;
  FAllowedItems := AllowedItems;
  FLastItem := nil;
  ViewNew.Clear;
  TreeNew.Items.Clear;
  if [ntSolutions..ntFiles] * AllowedItems <> [] then
  begin
    StdRoot := TreeNew.Items.AddChild(nil, sStandard);
    if ntSolutions in AllowedItems then
    begin
      Item := TreeNew.Items.AddChildObject(StdRoot, sSolutions,
        TObject(ntSolutions));
      Item.SelectedIndex := 1;
      
      if FLastCat = ntSolutions then
        TreeNew.Selected := Item;
    end;
    if ntProjects in AllowedItems then
    begin
      Item := TreeNew.Items.AddChildObject(StdRoot, sProjects,
        TObject(ntProjects));
      Item.SelectedIndex := 1;
      if FLastCat = ntProjects then
        TreeNew.Selected := Item;
    end;
    if ntFiles in AllowedItems then
    begin
      Item := TreeNew.Items.AddChildObject(StdRoot, sNewFiles,
        TObject(ntFiles));
      Item.SelectedIndex := 1;
      if FLastCat = ntFiles then
        TreeNew.Selected := Item;
    end;
  end;

 { if ntTemplates in AllowedItems then
  begin
    TempRoot := TreeNew.Items.AddChild(nil, sTemplates);
  end;}
  if (TreeNew.Items[0].Item[0] <> nil) and (TreeNew.Selected = nil) then
    TreeNew.Selected := TreeNew.Items[0].Item[0];
  TreeNew.FullExpand;

  if ShowModal = mrOK then
    Result := FLastItem;
end;

procedure TNewForm.TreeNewMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Idx: Long;
  Node: TTreeNode;
begin
  Node := TreeNew.GetNodeAt(X, Y);
  if Node <> nil then
  begin
    Idx := Header.ActivePage;
    case Node.Level of
      0: Idx := Node.Index;
      1: Idx := Node.Parent.Index;
    end;
    Header.ActivePage := Idx;
  end;
end;

procedure TNewForm.TreeNewChange(Sender: TObject; Node: TTreeNode);
begin
  if Node <> nil then
    if Node.Level > 0 then
    begin
      FLastCat := TNewItemCategory(Node.Data);
      case FLastCat of
        ntSolutions: MainActions.FillNewItems(ntSolutions, ViewNew);
        ntProjects: MainActions.FillNewItems(ntProjects, ViewNew);
        ntFiles: MainActions.FillNewItems(ntFiles, ViewNew);
      end;
    end;
end;

procedure TNewForm.ViewNewChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  if (TreeNew.Selected <> nil) and (Item <> nil) then
  begin
    LabSelCat.Caption := Format('%s: (%s)', [TreeNew.Selected.Text,
      Item.Caption]);
    FlastItem := Item.Data;
  end;
end;

procedure TNewForm.ViewNewDblClick(Sender: TObject);
begin
  if ViewNew.Selected <> nil then
    BtnOK.Click;
end;

procedure TNewForm.TreeNewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if TreeNew.GetNodeAt(X, Y) <> nil then
    TreeNew.Select(TreeNew.GetNodeAt(X, Y));
end;

procedure TNewForm.TreeNewCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
  AllowCollapse:=False;
end;

end.

