unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls, ToolWin, StdCtrls, ActnList,
  ActnCtrls, VideVclActions, ActnMan, ActnMenus, StdActns, ActnColorMaps,
  FEditor, ImgList, XPStyleActnCtrls, AMainActions, Kernel,
  AEditorActions, CSingletons, FEditorOptions, FFileNew, FEnvOptions,
  FProjectOptions, ActnPopupCtrl, AExpActions, CProjects, FAbout,
  ABase, ANewItems, AConsts, FSaveChanges, SynEditTypes, FSearch, FReplace,
  StdStyleActnCtrls, AOptions, ACompilers, ShellAPI, FIles;

type
  TMainForm = class(TForm)
    Splitter1: TSplitter;
    PanelMsg: TPanel;
    ControlBar: TControlBar;
    MainMenuBar: TActionMainMenuBar;
    ActionsFile: TActionList;
    FileImages: TImageList;
    About: TAction;
    ActionsView: TActionList;
    ViewExplorer: TAction;
    ActionImages: TImageList;
    FileSave: TAction;
    FileSaveAll: TAction;
    FileExit: TFileExit;
    NewUnit: TAction;
    NewSolution: TAction;
    NewGUIApp: TAction;
    NewOther: TAction;
    ViewMessages: TAction;
    ViewEditor: TAction;
    FileClose: TAction;
    FileCloseAll: TAction;
    ActionsProject: TActionList;
    ProjectActiveOptions: TAction;
    ActionsTools: TActionList;
    ToolsEnvironment: TAction;
    PopupExp: TPopupActionBarEx;
    Explorer1: TMenuItem;
    ExplorerActions: TActionList;
    PopupSolution: TPopupActionBarEx;
    Solution1: TMenuItem;
    PopupFile: TPopupActionBarEx;
    PopupProject: TPopupActionBarEx;
    Project1: TMenuItem;
    Options1: TMenuItem;
    ExpHideExplorer: TAction;
    N2: TMenuItem;
    HideExplorer1: TMenuItem;
    N3: TMenuItem;
    HideExplorer2: TMenuItem;
    N4: TMenuItem;
    Hide1: TMenuItem;
    ActionsSolution: TActionList;
    SolAddProject: TAction;
    SolAddNewProject: TAction;
    ExpOpenFile: TAction;
    N5: TMenuItem;
    SolOptions: TAction;
    ProjectActiveAdd: TAction;
    ProjectExpAdd: TAction;
    ProjectActivate: TAction;
    Activate1: TMenuItem;
    FileSaveAs: TAction;
    FileSaveProjectAs: TAction;
    FileSaveSolAs: TAction;
    FileOpen: TAction;
    FileOpenSol: TAction;
    AddNewProject1: TMenuItem;
    ImagesExp: TImageList;
    ProjectActiveNew: TAction;
    ProjectExpNew: TAction;
    AddNewFile1: TMenuItem;
    SolViewSource: TAction;
    ProjectActiveSource: TAction;
    ProjectExpSource: TAction;
    ViewSource1: TMenuItem;
    ViewSource2: TMenuItem;
    N7: TMenuItem;
    NewConsoleApp: TAction;
    FileSaveItems: TAction;
    SolRename: TAction;
    ExpRename: TAction;
    Close1: TMenuItem;
    Rename1: TMenuItem;
    Rename2: TMenuItem;
    ProjectActiveRename: TAction;
    ToolbarFile: TActionToolBar;
    ToolBarEdit: TActionToolBar;
    PanelTop: TPanel;
    Splitter2: TSplitter;
    PanelExp: TPanel;
    TabExp: TTabControl;
    TreeExp: TTreeView;
    PanelEditor: TPanel;
    EditorFrame: TEditorFrame;
    ActionManager: TActionManager;
    ProjectExpRemove: TAction;
    Remove1: TMenuItem;
    SolRemoveExp: TAction;
    About1: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N1: TMenuItem;
    ProjectExpOptions: TAction;
    ExpActivateFile: TAction;
    Activate2: TMenuItem;
    SolBuild: TAction;
    SolCompile: TAction;
    ProjectActiveBuild: TAction;
    ProjectExpBuild: TAction;
    ProjectActiveRun: TAction;
    ProjectExpRun: TAction;
    ProjectActiveCompile: TAction;
    ProjectExpCompile: TAction;
    CompileAll1: TMenuItem;
    BuildAll1: TMenuItem;
    N6: TMenuItem;
    Run1: TMenuItem;
    Compile1: TMenuItem;
    Build1: TMenuItem;
    N10: TMenuItem;
    PanelMain: TPanel;
    ListMsg: TListView;
    ToolBarSearch: TActionToolBar;
    N11: TMenuItem;
    ToolBarRun: TActionToolBar;
    ShowInfo: TAction;
    procedure ViewEditorExecute(Sender: TObject);
    procedure FileCloseExecute(Sender: TObject);
    procedure FileCloseUpdate(Sender: TObject);
    procedure FileCloseAllExecute(Sender: TObject);
    procedure NewOtherExecute(Sender: TObject);
    procedure ToolsEnvironmentExecute(Sender: TObject);
    procedure ProjectActiveOptionsExecute(Sender: TObject);
    procedure ViewEditorUpdate(Sender: TObject);
    procedure ViewExplorerExecute(Sender: TObject);
    procedure ViewExplorerUpdate(Sender: TObject);
    procedure ViewMessagesExecute(Sender: TObject);
    procedure ViewMessagesUpdate(Sender: TObject);
    procedure ExpHideExplorerExecute(Sender: TObject);
    procedure TreeExpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExpOpenFileExecute(Sender: TObject);
    procedure TreeExpDblClick(Sender: TObject);
    procedure SolAddNewProjectExecute(Sender: TObject);
    procedure ProjectActiveAddExecute(Sender: TObject);
    procedure ProjectExpAddExecute(Sender: TObject);
    procedure ProjectActivateExecute(Sender: TObject);
    procedure FileSaveUpdate(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FileSaveProjectAsExecute(Sender: TObject);
    procedure FileSaveAsExecute(Sender: TObject);
    procedure FileSaveAsUpdate(Sender: TObject);
    procedure FileSaveSolAsExecute(Sender: TObject);
    procedure FileOpenExecute(Sender: TObject);
    procedure FileOpenSolExecute(Sender: TObject);
    procedure SolAddProjectExecute(Sender: TObject);
    procedure TreeExpGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure AboutExecute(Sender: TObject);
    procedure ProjectExpNewExecute(Sender: TObject);
    procedure ProjectActiveNewExecute(Sender: TObject);
    procedure SolViewSourceExecute(Sender: TObject);
    procedure ProjectActiveSourceExecute(Sender: TObject);
    procedure ProjectExpSourceExecute(Sender: TObject);
    procedure NewSolutionExecute(Sender: TObject);
    procedure NewUnitExecute(Sender: TObject);
    procedure NewGUIAppExecute(Sender: TObject);
    procedure NewConsoleAppExecute(Sender: TObject);
    procedure FileSaveAllExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FileSaveItemsExecute(Sender: TObject);
    procedure SolRenameExecute(Sender: TObject);
    procedure TreeExpEdited(Sender: TObject; Node: TTreeNode;
      var S: string);
    procedure ExpRenameExecute(Sender: TObject);
    procedure ProjectActiveRenameExecute(Sender: TObject);
    procedure TreeExpCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure ProjectExpRemoveExecute(Sender: TObject);
    procedure SolRemoveExpExecute(Sender: TObject);
    procedure ProjectActiveRenameUpdate(Sender: TObject);
    procedure ProjectActiveSourceUpdate(Sender: TObject);
    procedure ProjectActiveNewUpdate(Sender: TObject);
    procedure ProjectActiveAddUpdate(Sender: TObject);
    procedure ProjectActiveOptionsUpdate(Sender: TObject);
    procedure FileSaveProjectAsUpdate(Sender: TObject);
    procedure ProjectExpOptionsExecute(Sender: TObject);
    procedure ExpActivateFileExecute(Sender: TObject);
    procedure ProjectExpCompileExecute(Sender: TObject);
    procedure ProjectActiveCompileExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ProjectActiveCompileUpdate(Sender: TObject);
    procedure ProjectActiveRunUpdate(Sender: TObject);
    procedure ProjectActiveBuildUpdate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ProjectActiveRunExecute(Sender: TObject);
    procedure ProjectExpRunExecute(Sender: TObject);
    procedure ProjectExpBuildExecute(Sender: TObject);
    procedure ProjectActiveBuildExecute(Sender: TObject);
    procedure SolCompileExecute(Sender: TObject);
    procedure SolBuildExecute(Sender: TObject);
    procedure ShowInfoExecute(Sender: TObject);
  private
    FFirstShow:Boolean;
  public
  end;

var
  MainForm: TMainForm;

implementation

uses
  FData;

{$R *.dfm}

procedure TMainForm.ViewEditorExecute(Sender: TObject);
begin
  PanelEditor.Visible := not PanelEditor.Visible;
end;

procedure TMainForm.ViewEditorUpdate(Sender: TObject);
begin
  ViewEditor.Checked := EditorActions.EditorVisible;
  ViewEditor.Enabled := Editor.Count > 0;
end;

procedure TMainForm.FileCloseExecute(Sender: TObject);
begin
  MainActions.CloseFile;
end;

procedure TMainForm.FileCloseUpdate(Sender: TObject);
begin
  FileClose.Enabled := Editor.Count > 0;
end;

procedure TMainForm.FileCloseAllExecute(Sender: TObject);
begin
  MainActions.CloseAll;
end;

procedure TMainForm.NewOtherExecute(Sender: TObject);
begin
  MainActions.NewItem(AllNewItems);
end;

procedure TMainForm.ToolsEnvironmentExecute(Sender: TObject);
begin
  EnvForm.ShowModal;
end;

procedure TMainForm.ProjectActiveOptionsExecute(Sender: TObject);
begin
  ProjectForm.ShowOptions(Solution.ActiveProject);
end;

procedure TMainForm.ViewExplorerExecute(Sender: TObject);
begin
  PanelExp.Visible := not PanelExp.Visible;
end;

procedure TMainForm.ViewExplorerUpdate(Sender: TObject);
begin
  ViewExplorer.Checked := PanelExp.Visible;
end;

procedure TMainForm.ViewMessagesExecute(Sender: TObject);
begin
  PanelMsg.Visible := not PanelMsg.Visible;
  if PanelMsg.Visible then
    Splitter1.Top:=PanelMsg.Top;
end;

procedure TMainForm.ViewMessagesUpdate(Sender: TObject);
begin
  ViewMessages.Checked := PanelMsg.Visible;
end;

procedure TMainForm.ExpHideExplorerExecute(Sender: TObject);
begin
  ViewExplorer.Execute;
end;

procedure TMainForm.TreeExpMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if TreeExp.GetNodeAt(X, Y) <> nil then
    TreeExp.Select(TreeExp.GetNodeAt(X, Y));
  case TabExp.TabIndex of
    ExpSolution:
      if TreeExp.Selected <> nil then
        case TreeExp.Selected.Level of
          0: TreeExp.PopupMenu := PopupSolution;
          1: TreeExp.PopupMenu := PopupProject;
          2: TreeExp.PopupMenu := PopupFile;
        end;
  end;
end;

procedure TMainForm.ExpOpenFileExecute(Sender: TObject);
begin
  MainActions.OpenFile(TVideFile(TreeExp.Selected.Data).FileName);
end;

procedure TMainForm.TreeExpDblClick(Sender: TObject);
begin
  case TabExp.TabIndex of
    ExpSolution:
      if TreeExp.Selected <> nil then
        case TreeExp.Selected.Level of
          2: ExpOpenFile.Execute;
        end;
  end;
end;

procedure TMainForm.SolAddNewProjectExecute(Sender: TObject);
begin
  MainActions.NewItem([ntProjects]);
end;

procedure TMainForm.ProjectActiveAddExecute(Sender: TObject);
begin
  MainActions.AddFiles(Solution.ActiveProject, True);
end;

procedure TMainForm.ProjectExpAddExecute(Sender: TObject);
begin
  MainActions.AddFiles(TVideProject(TreeExp.Selected.Data), True);
end;

procedure TMainForm.ProjectActivateExecute(Sender: TObject);
begin
  Solution.ActiveIndex := TreeExp.Selected.Index;
end;

procedure TMainForm.FileSaveAsExecute(Sender: TObject);
begin
  MainActions.SaveFile(Editor.ActiveFile, True);
end;

procedure TMainForm.FileSaveAsUpdate(Sender: TObject);
begin
  FileSaveAs.Enabled := Editor.ActiveFile <> nil;
end;

procedure TMainForm.FileSaveUpdate(Sender: TObject);
begin
  FileSave.Enabled := Editor.ActiveFile <> nil;
end;

procedure TMainForm.FileSaveExecute(Sender: TObject);
begin
  MainActions.SaveFile(Editor.ActiveFile);
end;

procedure TMainForm.FileSaveProjectAsExecute(Sender: TObject);
begin
  MainActions.SaveProject(Solution.ActiveProject, True);
end;

procedure TMainForm.FileSaveSolAsExecute(Sender: TObject);
begin
  MainActions.SaveSolution(True);
end;

procedure TMainForm.FileOpenExecute(Sender: TObject);
begin
  MainActions.OpenFiles(True);
end;

procedure TMainForm.FileOpenSolExecute(Sender: TObject);
begin
  MainActions.OpenSolution(True);
end;

procedure TMainForm.SolAddProjectExecute(Sender: TObject);
begin
  MainActions.AddProjects(True);
end;

procedure TMainForm.TreeExpGetImageIndex(Sender: TObject; Node: TTreeNode);
begin
  Node.ImageIndex := -1;
  case TabExp.TabIndex of
    ExpSolution: case Node.Level of
        0: Node.ImageIndex := 2;
        1:
          begin
            if Node.Index = Solution.ActiveIndex then
              Node.ImageIndex := 1
            else
              Node.ImageIndex := 0;
          end;
        2: Node.ImageIndex := 3;
      end;
  end;
  Node.SelectedIndex := Node.ImageIndex;
end;

procedure TMainForm.AboutExecute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.ProjectExpNewExecute(Sender: TObject);
begin
  MainActions.NewItem([ntFiles], TVideProject(TreeExp.Selected.Data));
end;

procedure TMainForm.ProjectActiveNewExecute(Sender: TObject);
begin
  MainActions.NewItem([ntFiles]);
end;

procedure TMainForm.SolViewSourceExecute(Sender: TObject);
begin
  MainActions.SolViewSource;
end;

procedure TMainForm.ProjectActiveSourceExecute(Sender: TObject);
begin
  MainActions.ProjectViewSource(Solution.ActiveProject);
end;

procedure TMainForm.ProjectExpSourceExecute(Sender: TObject);
begin
  MainActions.ProjectViewSource(TVideProject(TreeExp.Selected.Data));
end;

procedure TMainForm.NewSolutionExecute(Sender: TObject);
begin
  MainActions.NewItem(sBlankSolution);
end;

procedure TMainForm.NewUnitExecute(Sender: TObject);
begin
  MainActions.NewItem(sPascalUnit, Solution.ActiveProject);
end;

procedure TMainForm.NewGUIAppExecute(Sender: TObject);
begin
  MainActions.NewItem(sGUIApplication);
end;

procedure TMainForm.NewConsoleAppExecute(Sender: TObject);
begin
  MainActions.NewItem(sConsoleApplication);
end;

procedure TMainForm.FileSaveAllExecute(Sender: TObject);
begin
  MainActions.SaveAll;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := MainActions.CloseApp;
end;

procedure TMainForm.FileSaveItemsExecute(Sender: TObject);
begin
  MainActions.SaveItems;
end;

procedure TMainForm.SolRenameExecute(Sender: TObject);
var
  S: string;
begin
  S := Solution.Name;
  if Dialogs.InputQuery('Rename Solution',
    'Enter new solution name (old file will be deleted):', S) then
    MainActions.SolRename(S);
end;

procedure TMainForm.TreeExpEdited(Sender: TObject; Node: TTreeNode;
  var S: string);
begin
  case TabExp.TabIndex of
    ExpSolution: case Node.Level of
        0:
          if not MainActions.SolRename(S) then
            S := Node.Text;
        1:
          if not MainActions.ProjectRename(TVideProject(Node.Data), S) then
            S := Node.Text;
        2:
          if not MainActions.FileRename(TVideFile(Node.Data), S) then
            S := Node.Text;
      end;
  end;
end;

procedure TMainForm.ExpRenameExecute(Sender: TObject);
begin
  if TreeExp.Selected <> nil then
    TreeExp.Selected.EditText;
end;

procedure TMainForm.ProjectActiveRenameExecute(Sender: TObject);
var
  S: string;
begin
  S := Solution.ActiveProject.Name;
  if Dialogs.InputQuery('Rename Project',
    'Enter new project name (old file will be deleted):', S) then
    MainActions.ProjectRename(Solution.ActiveProject, S);
end;

procedure TMainForm.TreeExpCustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  DefaultDraw := True;
    case TabExp.TabIndex of
      ExpSolution: case Node.Level of
          0: begin
              TreeExp.Canvas.Font.Style := [fsBold];
              TreeExp.Canvas.Refresh;
            end;
          1:
            if Node.Index = Solution.ActiveIndex then
            begin
              TreeExp.Canvas.Font.Style := [fsBold];
              TreeExp.Canvas.Refresh;
            end;
           2:
            if Node.Data<>nil then
            if (Node.Index = TVideProject(Node.Parent.Data).ActiveIndex) then
            begin
              TreeExp.Canvas.Font.Style := [fsBold];
              TreeExp.Canvas.Refresh;
            end;
        end;
    end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  ReplaceForm.ShowModal;
end;

procedure TMainForm.ProjectExpRemoveExecute(Sender: TObject);
begin
  MainActions.ProjectRemove(TVideFile(TreeExp.Selected.Data), True);
end;

procedure TMainForm.SolRemoveExpExecute(Sender: TObject);
begin
  MainActions.SolRemove(TVideProject(TreeExp.Selected.Data), True);
end;

procedure TMainForm.ProjectActiveRenameUpdate(Sender: TObject);
begin
  ProjectActiveRename.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectActiveSourceUpdate(Sender: TObject);
begin
  ProjectActiveSource.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectActiveNewUpdate(Sender: TObject);
begin
ProjectActiveNew.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectActiveAddUpdate(Sender: TObject);
begin
  ProjectActiveAdd.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectActiveOptionsUpdate(Sender: TObject);
begin
  ProjectActiveOptions.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.FileSaveProjectAsUpdate(Sender: TObject);
begin
  FileSaveProjectAs.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectExpOptionsExecute(Sender: TObject);
begin
  ProjectForm.ShowOptions(TVideProject(TreeExp.Selected.Data));
end;

procedure TMainForm.ExpActivateFileExecute(Sender: TObject);
begin
  TVideFile(TreeExp.Selected.Data).Project.ActiveIndex:=TreeExp.Selected.Index;
  MainActions.ActivateFile(TVideFile(TreeExp.Selected.Data));
end;

procedure TMainForm.ProjectExpCompileExecute(Sender: TObject);
begin
  MainActions.ProjectCompile(TVideProject(TreeExp.Selected.Data), True, False, True);
end;

procedure TMainForm.ProjectActiveCompileExecute(Sender: TObject);
begin
  MainActions.ProjectCompile(Solution.ActiveProject, True, False, True);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainActions.Finalize;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  if not FFirstShow then
  begin
    MainActions.FirstShow;
    FFirstShow:=True;
  end;
end;

procedure TMainForm.ProjectActiveCompileUpdate(Sender: TObject);
begin
  ProjectActiveCompile.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectActiveRunUpdate(Sender: TObject);
begin
  ProjectActiveRun.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.ProjectActiveBuildUpdate(Sender: TObject);
begin
  ProjectActiveBuild.Enabled:=Solution.ActiveProject <> nil;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  ListMsg.Columns[0].Width:=ListMsg.Width;
  // -  ListMsg.Columns[0].Width -
  //  ListMsg.Columns[1].Width;
end;

procedure TMainForm.ProjectActiveRunExecute(Sender: TObject);
begin
  MainActions.ProjectRun(Solution.ActiveProject);
end;

procedure TMainForm.ProjectExpRunExecute(Sender: TObject);
begin
  MainActions.ProjectRun(TVideProject(TreeExp.Selected.Data));
end;

procedure TMainForm.ProjectExpBuildExecute(Sender: TObject);
begin
  MainActions.ProjectBuild(TVideProject(TreeExp.Selected.Data));
end;

procedure TMainForm.ProjectActiveBuildExecute(Sender: TObject);
begin
  MainActions.ProjectBuild(Solution.ActiveProject);
end;

procedure TMainForm.SolCompileExecute(Sender: TObject);
var
  I, Cnt:Long;
begin
  Cnt:=0;
  MainForm.ListMsg.Items.Clear;
  for I:=0 to Solution.Count-1 do
    if MainActions.ProjectCompile(Solution.Projects[I], False, False, False) then
      Inc(Cnt);
  LineOutput('');    
  LineOutput(Format('%d of %d projects successfuly compiled.', [Cnt, Solution.Count]));
end;

procedure TMainForm.SolBuildExecute(Sender: TObject);
var
  I, Cnt:Long;
begin
  Cnt:=0;
  MainForm.ListMsg.Items.Clear;
  for I:=0 to Solution.Count-1 do
    if MainActions.ProjectCompile(Solution.Projects[I], False, True, False) then
      Inc(Cnt);
  LineOutput('');
  LineOutput(Format('%d of %d projects successfuly build.', [Cnt, Solution.Count]));
end;

procedure TMainForm.ShowInfoExecute(Sender: TObject);
begin
  ShellExecute(0,'open',PChar(Vfs.GetFullFileName('$(ROOT)\Doc\Info.html')),nil,nil,SW_SHOW);
end;

end.

