unit FReplace;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, WizardHeader, AMainActions, ABase, SynEditTypes;

type
  TReplaceForm = class(TForm)
    WizardHeader1: TWizardHeader;
    Panel1: TPanel;
    LabText: TLabeledEdit;
    GroupOptions: TGroupBox;
    CheckCase: TCheckBox;
    CheckWhole: TCheckBox;
    GroupDir: TRadioGroup;
    GroupScope: TRadioGroup;
    GroupOrigin: TRadioGroup;
    Panel2: TPanel;
    RepAll: TButton;
    Cancel: TButton;
    Button1: TButton;
    LabReplace: TLabeledEdit;
    CheckPrompt: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure RepAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FReplaceAll: Boolean;
  public
    function Replace(Opt: TSearchOptions): Boolean;
    function GetOptions: TSearchOptions;
  end;

var
  ReplaceForm: TReplaceForm;

implementation

{$R *.dfm}

procedure TReplaceForm.Button1Click(Sender: TObject);
begin
  if LabText.Text = '' then
    MainActions.ErrorDlg('The search string can not be blank.', 'Error')
  else
  begin
    ModalResult := mrOK;
    Hide;
  end;
end;

function TReplaceForm.GetOptions: TSearchOptions;
begin
  Result.Text := LabText.Text;
  Result.ReplaceText := LabReplace.Text;
  Result.SynOptions := [ssoReplace];
  if CheckCase.Checked then
    Include(Result.SynOptions, ssoMatchCase);
  if CheckWhole.Checked then
    Include(Result.SynOptions, ssoWholeWord);
  if CheckPrompt.Checked then
    Include(Result.SynOptions, ssoPrompt);
  if GroupDir.ItemIndex = 1 then
    Include(Result.SynOptions, ssoBackwards);
  if GroupScope.ItemIndex = 1 then
    Include(Result.SynOptions, ssoSelectedOnly);
  if GroupOrigin.ItemIndex = 1 then
    Include(Result.SynOptions, ssoEntireScope);
  if FReplaceAll then
    Include(Result.SynOptions, ssoReplaceAll);
end;

procedure TReplaceForm.RepAllClick(Sender: TObject);
begin
  if LabText.Text = '' then
    MainActions.ErrorDlg('The search string can not be blank.', 'Error')
  else
  begin
    FReplaceAll := True;
    ModalResult := mrOK;
    Hide;
  end;
end;

function TReplaceForm.Replace(Opt: TSearchOptions): Boolean;
begin
  FReplaceAll := False;
  LabText.Text := Opt.Text;
  LabReplace.Text := Opt.ReplaceText;
  CheckCase.Checked := ssoMatchCase in Opt.SynOptions;
  CheckWhole.Checked := ssoWholeWord in Opt.SynOptions;
  CheckPrompt.Checked := ssoPrompt in Opt.SynOptions;
  GroupDir.ItemIndex := Ord(ssoBackwards in Opt.SynOptions);
  GroupScope.ItemIndex := Ord(ssoSelectedOnly in Opt.SynOptions);
  GroupOrigin.ItemIndex := Ord(ssoEntireScope in Opt.SynOptions);
  Result := ShowModal = mrOK;
end;

procedure TReplaceForm.FormShow(Sender: TObject);
begin
  LabText.SetFocus;
end;

end.

