unit FSearch;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, WizardHeader, SynEditTypes, AEditorActions,
  AMainActions, ABase;

type
  TSearchForm = class(TForm)
    WizardHeader1: TWizardHeader;
    Panel1: TPanel;
    Panel2: TPanel;
    OK: TButton;
    Cancel: TButton;
    LabText: TLabeledEdit;
    GroupOptions: TGroupBox;
    GroupDir: TRadioGroup;
    GroupScope: TRadioGroup;
    GroupOrigin: TRadioGroup;
    CheckCase: TCheckBox;
    CheckWhole: TCheckBox;
    procedure OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
    function Find(Opt:TSearchOptions): Boolean;
    function GetOptions: TSearchOptions;
  end;

var
  SearchForm: TSearchForm;

implementation

{$R *.dfm}

{ TSearchForm }

function TSearchForm.Find(Opt:TSearchOptions): Boolean;
begin
  LabText.Text := Opt.Text;
  CheckCase.Checked:=ssoMatchCase in Opt.SynOptions;
  CheckWhole.Checked:=ssoWholeWord in Opt.SynOptions;
  GroupDir.ItemIndex:=Ord(ssoBackwards in Opt.SynOptions);
  GroupScope.ItemIndex:=Ord(ssoSelectedOnly in Opt.SynOptions);
  GroupOrigin.ItemIndex:=Ord(ssoEntireScope in Opt.SynOptions);
  Result := ShowModal = mrOK;
end;

function TSearchForm.GetOptions: TSearchOptions;
begin
  Result.Text := LabText.Text;
  Result.SynOptions := [];
  if CheckCase.Checked then
    Include(Result.SynOptions, ssoMatchCase);
  if CheckWhole.Checked then
    Include(Result.SynOptions, ssoWholeWord);
  if GroupDir.ItemIndex = 1 then
    Include(Result.SynOptions, ssoBackwards);
  if GroupScope.ItemIndex = 1 then
    Include(Result.SynOptions, ssoSelectedOnly);
  if GroupOrigin.ItemIndex = 1 then
    Include(Result.SynOptions, ssoEntireScope);
end;

procedure TSearchForm.OKClick(Sender: TObject);
begin
  if LabText.Text = '' then
    MainActions.ErrorDlg('The search string can not be blank.', 'Error')
  else
  begin
    ModalResult := mrOK;
    Hide;
  end;
end;

procedure TSearchForm.FormShow(Sender: TObject);
begin
  LabText.SetFocus;
end;

end.

