program %s;

{$APPTYPE GUI}

uses
  Windows,
  Messages;

const
  AppName = '%sWindowClass';
  WindowName = '%s';

function WindowProc(Window: HWnd; AMessage, WParam,
  LParam: LongInt): LongInt; stdcall;
begin
  Result := 0;
  case AMessage of
    WM_DESTROY:
      begin
        PostQuitMessage(0);
        Exit;
      end;
  end;
  Result := DefWindowProc(Window, AMessage, WParam, LParam);
end;

{ Register the Window Class }
function WinRegister: Boolean;
var
  WindowClass: WndClass;
begin
  WindowClass.Style := CS_HREDRAW or CS_VREDRAW;
  WindowClass.lpfnWndProc := @WindowProc;
  WindowClass.cbClsExtra := 0;
  WindowClass.cbWndExtra := 0;
  WindowClass.hInstance := MainInstance;
  WindowClass.hIcon := LoadIcon(0, IDI_APPLICATION);
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hbrBackground := GetStockObject(WHITE_BRUSH);
  WindowClass.lpszMenuName := nil;
  WindowClass.lpszClassName := AppName;

  Result := RegisterClass(WindowClass) <> 0;
end;

{ Create the Window Class }
function WinCreate: HWnd;
var
  HWindow: HWnd;
begin
  HWindow := CreateWindow(AppName, WindowName,
    WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
    400, 300, 0, 0, MainInstance, nil);

  if HWindow <> 0 then
  begin
    ShowWindow(hWindow, CMDSHOW);
    UpdateWindow(hWindow);
  end;

  Result := HWindow;
end;

var
  AMessage: TMsg;
  HWindow: HWnd;

begin
  if not WinRegister then
  begin
    MessageBox(0, 'Window class registration failed.', nil,
      MB_OK or MB_ICONERROR);
    Exit;
  end;
  HWindow := WinCreate;
  if HWindow = 0 then
  begin
    MessageBox(0, 'Window creation failed.', nil, MB_OK or MB_ICONERROR);
    Exit;
  end;

{$IFDEF FPC}
  while GetMessage(@AMessage, 0, 0, 0) do
  begin
    TranslateMessage(@AMessage);
    DispatchMessage(@AMessage);
  end;
{$ELSE}
  while GetMessage(AMessage, 0, 0, 0) do
  begin
    TranslateMessage(AMessage);
    DispatchMessage(AMessage);
  end;
{$ENDIF}
end.


