{*************************************************************************}
{*   Vide                                                                *}
{*   Copyright (C) 2004 Marek Mauder, Vampyre SoftWorks                  *}
{*   Vide.pas                                                            *}
{*************************************************************************}
{                                                                         }
{ This program is free software; you can redistribute it and/or modify it }
{ under the terms of the GNU General Public License as published by the   }
{ Free Software Foundation; either version 2 of the License, or (at your  }
{ option) any later version. This program is distributed in the hope that }
{ it will be useful, but WITHOUT ANY WARRANTY; without even the implied   }
{ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See   }
{ the GNU General Public License for more details.                        }
{                                                                         }
{ You should have received a copy of the GNU General Public License       }
{ along with this program; if not, write to the Free Software Foundation, }
{ Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         }
{                                                                         }
{*************************************************************************}
{  Created On: 02nd April 2004  (02.04.2004)                              }
{*************************************************************************}

program Vide;

{$I Compiler.inc}
{$I Options.inc}

{ TODOS:
Main:
  * Search/Replace
  * Finish About
  * Remove from projects/solutions
  * Environment options
  * Editor options
  --- Solution options
  * Project options
  * Run/Compile/Build
  --- Put built in new items to resource
  * Solve Undo/Redo when changing active editor file
  * Store all setings


Misc:
  - When renaming solution in explorer - there is number of projects in editbox
  * Ask when closing modified files (Yes/No/Cancel)
  - Add file monitoring (file was changed outside Vide. Reload?)
  * Moving Tabs in source editor
  - Dropping files to explorer/editor (from windows, from editor)
  - Redesign GetFilter
  * Save All
  * Add toolars
  * Delete newly created but closed and unsaved items from owners
  * Rename units/projects/solutions in explorer
  - Edit/Format: Indent/Unindent, Comment/Uncommnet, ...
  - Addto source: unit header,
  - Add solution files
  - Add folders to projects
  - Open recent files
  - when opening: project XX was not found! File XXX was not found!
  - Remember Last file/proj/sol name and use it in ope dialog
  - Add ReadOnly to editor files
  - Add list of opened pages when click on editor tab
  * Add (*) to editor Tabs when file is modified
  * Check repeating names when saveas/rename
  - Add File Properties (time, size, lines, ....)
  - Move Images, ... to DataModule
  - Search/Replace for all files/project/solution/directorry
  - Remove memory leaks
  - Make blocks persistent when - lower/upper/indent...
  - Add remove from project/solution to menu (form like save items)
  - When removing file, close it if opened in editor (ask to save)
  - Code snipsets
  - ctrl+shift+g - generate guid
  - when adding new extension to file type - check if it already exists
  - open files with CanOpenToEditor = False with associated program
  - add customizing colors to Envirinment/Appearance
}

uses
  Kernel,
  Platforms,
  Forms,
  AMainActions,
  FMain,
  FSplash,
  FEditorOptions,
  FFileNew,
  FEnvOptions,
  FProjectOptions,
  FAbout,
  FSaveChanges,
  FData,
  FSearch,
  FReplace;

{$R *.res}

begin
  Application.Initialize;
  SplashForm := TSplashForm.Create(nil);
  SplashForm.Show;
  SplashForm.Update;
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TEditorOptionsForm, EditorOptionsForm);
  Application.CreateForm(TNewForm, NewForm);
  Application.CreateForm(TEnvForm, EnvForm);
  Application.CreateForm(TProjectForm, ProjectForm);
  Application.CreateForm(TAboutForm, AboutForm);
  Application.CreateForm(TSaveForm, SaveForm);
  Application.CreateForm(TData, Data);
  Application.CreateForm(TSearchForm, SearchForm);
  Application.CreateForm(TReplaceForm, ReplaceForm);
  // load settings, projects ...
  MainActions.Initialize;
 // Platform.Sleep(100);
  SplashForm.Hide;
  Application.Run;
  SplashForm.Free;
end.

